rem =====================================
rem =====================================
rem COMBINED APPROACH TDYN-AND-RAMSERIES:
rem =====================================
rem =====================================


rem TDYN DATAFILE:
copy %1.dat.tdyn %1.tdyn.dat


rem RAMS DATAFILE:
rem copy %1.dat %1.ramseries.dat
rem leave as is.


rem    -*- TCL -*-
rem    OutputFile: %2\%1.tdyn.dat.inf
rem    OutputFile: %2\%1.info
rem    ErrorFile: %2\%1.tdyn.dat.err
rem    WarningFile: %2\%1.tdyn.dat.war
rem    WarningFile: %2\%1.tdyn.warnings
tcl

proc LaunchTdynAndRamseries { basename dir problemtypedir } {
    global RunningProcess

    set err [catch {
	foreach i [list .flavia .flavia.res .flavia.err .flavia.error .tdyn.dat.err .flavia.war .flavia.inf \
		       .flaviafnl .flaviafnl.err .flaviafnl.war .flaviafnl.inf] {
	    if { [file exists [file join $dir $basename$i]] } {
		file delete [file join $dir $basename$i]
	    }
	}
	foreach i [list .error .info .war .warnings] {
	    if { [file exists [file join $dir $basename$i]] } {
		file delete [file join $dir $basename$i]
	    }
	}
	} errstring]
    
    for { set port 9300 } { $port <= 9320 } { incr port } {
	set err [catch { socket -server "" $port } sock]
	if { !$err } {
	    close $sock
	    break
	}
    }
    if { $port > 9320 } {
	set fout [open [file join $dir $basename.flavia.err] a]
	puts $fout "Failed to open TCP-IP port in the range 9300-9320."
	puts $fout "Contact your system administrator and check firewalls and anti-virus"
	close $fout
	return
    }

# puts $fprueba "Tras Abrir Puerto\n"

######################################
#check for installed Tdyn executables#
######################################


    set exe [file join $problemtypedir . exec tdyn.exe]
    set dat [file join $dir $basename.tdyn.dat]
    #set out1 [file join $dir $basename.flavia.inf]
    set out1 [file join $dir $basename.tdyn.dat.inf]
    set err1 [file join $dir $basename.tdyn.dat.err]

    # NOTE: the timeout 50000 means 50 seconds.

    set pid1 [exec $exe -3d -name $dat -coupling $port 50000 > $out1 &]

# puts $fprueba "Tras Ejecutar $pid1\n"

    set exe [file join $problemtypedir . exec ramseries.exe]
    
#set dat [file nativename [file join $dir $basename.ramseries.dat]]

    set dat [file join $dir $basename.dat]
    set out2 [file join $dir $basename.out]
    set err2 [file join $dir $basename.error]
    set inf2 [file join $dir $basename.info]

	# Temporal change until new reading of results in the post process will be finished
	# -p Write mesh
	# -relements renumber elements starting in 1
	#set pid2 [exec $exe -i $inf2 -tdyncoupling $port 50000 -p -relements $dat &]
    set pid2 [exec $exe -i $inf2 -tdyncoupling $port 50000 $dat &]
	

# puts $fprueba "Tras Ejecutar $pid2\n"

    set RunningProcess running
    set ErrorInProcess "no"
    while 1 {
 	if { $RunningProcess == "" } {
 	    if { [isalive $pid1] } {  kill $pid1 }
 	    if { [isalive $pid2] } {  kill $pid2 }
 	    vwait forever
 	}
 	if { ![isalive $pid1] && ![isalive $pid2] } { break }
 	if { ![isalive $pid1] && [file exists $err1] && [file size $err1] > 0 } {
 	    kill $pid2
 	    set ErrorInProcess "yes"
	    break
        }	
 	if { ![isalive $pid2] && [file exists $err2] && [file size $err2] > 0 } {
 	    kill $pid1
 	    set ErrorInProcess "yes"
 	    break
 	}
	after 200
        update
     }

## puts $fprueba "Tras Acabar\n"

    if { $ErrorInProcess=="no" } {
	if { ![file exists [file join $dir $basename.flavia.res]] || \
		[file size [file join $dir $basename.flavia.res]] == 0 } {
	    set fout [open [file join $dir $basename.flavia.error] a]
	    puts $fout "Ramseries failed. Results are not available."
	    close $fout
	}
	if { ![file exists [file join $dir $basename.tdyn.dat.res]]  || \
		[file size [file join $dir $basename.tdyn.dat.res]] == 0 } {
	    set fout [open [file join $dir $basename.tdyn.dat.err] a]
	    puts $fout "Tdyn failed. Results are not available."
	    close $fout
	} 
    }

# unimos los mensajes de error en un archivo: caso error de Tdyn
    set f [file join $dir $basename.tdyn.dat.err]
    if { [file exists $f] && [file size $f] > 0 } {
	set fin [open $f r]
	set fout [open [file join $dir $basename.flavia.err] a]
	puts -nonewline $fout [read $fin]
	set outtext " \"Tdyn has failed\" " 
	puts $fout $outtext
	close $fin
	close $fout
    }
# unimos los mensajes de error en un archivo: caso error de Ramseries
    set f [file join $dir $basename.flavia.error]
    if { [file exists $f] && [file size $f] > 0 } {
	set fin [open $f r]
	set fout [open [file join $dir $basename.flavia.err] a]
	puts -nonewline $fout [read $fin]
	set outtext " \"Ramseries has failed\" " 
	puts $fout $outtext
	close $fin
	close $fout
    }
}

foreach "- - basename dir problemtypedir -" $argv break
LaunchTdynAndRamseries $basename $dir $problemtypedir