<?xml version="1.0" encoding="utf-8"?><!-- -*-  mode: sgml; coding: utf-8;-*- -->
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method = "xml" indent = "yes" />

<xsl:template name='att'>
<xsl:for-each select="@*">
  <xsl:attribute name="{translate(name(),'ABCDEFGHIJKLMNOPQRSTUVWXYZ',
		                         'abcdefghijklmnopqrstuvwxyz')}">
  <xsl:value-of select="." /> 
  </xsl:attribute>
</xsl:for-each>
<xsl:apply-templates/>
</xsl:template>

<!-- The Identity Transformation -->
  <!-- Whenever you match any node or any attribute -->
  <xsl:template match="node()|@*">
    <!-- Copy the current node -->
    <xsl:copy>
      <!-- Including any attributes it has and any child nodes -->
      <xsl:apply-templates select="@*|node()"/>
    </xsl:copy>
  </xsl:template>

<xsl:template match="@*">
    <!-- Create the same element with a lowercase name -->
    <xsl:attribute name="{translate(name(),'ABCDEFGHIJKLMNOPQRSTUVWXYZ',
		                         'abcdefghijklmnopqrstuvwxyz')}">
      <!-- Including any attributes it has and any child nodes -->
      <xsl:apply-templates select="@*|node()"/>
	<xsl:value-of select="."/>
    </xsl:attribute>
  </xsl:template>

  <!-- When you match any element -->
  <xsl:template match="*">
    <!-- Create the same element with a lowercase name -->
    <xsl:element name="{translate(name(),'ABCDEFGHIJKLMNOPQRSTUVWXYZ',
		                         'abcdefghijklmnopqrstuvwxyz')}">
      <!-- Including any attributes it has and any child nodes -->
      <xsl:apply-templates select="@*|node()"/>
    </xsl:element>
  </xsl:template>

<xsl:template match="CHAPTER|SECT1|SECT2|SECT3|chapter|sect1|sect2|sect3">
<section><xsl:call-template name='att'/></section>
</xsl:template>

<xsl:template match="emphasis[@role='bold']|EMPHASIS[@role='BOLD']">
<emphasis role='strong'><xsl:apply-templates/></emphasis>
</xsl:template>

<xsl:template match="WORDASWORD|wordasword">
<emphasis role='strong'><xsl:call-template name='att'/></emphasis>
</xsl:template>

<xsl:template match="COMMAND|command">
<emphasis><xsl:call-template name='att'/></emphasis>
</xsl:template>

<xsl:template match="INFORMALFIGURE|informalfigure">
<para><xsl:call-template name='att'/></para>
</xsl:template>

<xsl:template match="IMAGEOBJECT">
<xsl:if test="IMAGEDATA[@FORMAT='jpg']">
<imageobject><xsl:call-template name='att'/></imageobject>
</xsl:if>
</xsl:template>

<xsl:template match="imageobject">
<xsl:if test="imagedata">
<imageobject><xsl:call-template name='att'/></imageobject>
</xsl:if>
</xsl:template>


<xsl:template match="IMAGEDATA">
<imagedata fileref='{@FILEREF}' align='{@ALIGN}' format='jpg'><xsl:apply-templates/></imagedata>
</xsl:template>

<xsl:template match="imagedata">
<imagedata fileref='{@fileref}' align='{@align}'><xsl:apply-templates/></imagedata>
</xsl:template>

<xsl:template match="XREF">
<ulink linktype='id' url='{@LINKEND}'><xsl:apply-templates/></ulink>
</xsl:template>

<xsl:template match="xref">
<ulink linktype='id' url='{@linkend}'><xsl:apply-templates/></ulink>
</xsl:template>

<xsl:template match="informaltable">
<table><xsl:apply-templates/></table>
</xsl:template>

<xsl:template match="literallayout">
<literal><xsl:apply-templates/></literal>
</xsl:template>

<xsl:template match="display">
<literal><xsl:apply-templates/></literal>
</xsl:template>

<xsl:template match="inlinemediaobject">
<mediaobject><xsl:apply-templates/></mediaobject>
</xsl:template>

<xsl:template match="screen">
<para><xsl:apply-templates/></para>
</xsl:template>

</xsl:stylesheet>
