<?xml version="1.0" encoding="utf-8"?><!-- -*- coding: utf-8;-*- -->
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method = "xml" indent = "yes" />

<xsl:template name='att'>
<xsl:for-each select="@*">
  <xsl:attribute name="{translate(name(),'ABCDEFGHIJKLMNOPQRSTUVWXYZ',
                                         'abcdefghijklmnopqrstuvwxyz')}">
  <xsl:value-of select="." /> 
  </xsl:attribute>
</xsl:for-each>
<xsl:apply-templates/>
</xsl:template>

<!-- The Identity Transformation -->
  <!-- Whenever you match any node or any attribute -->
  <xsl:template match="node()|@*">
    <!-- Copy the current node -->
    <xsl:copy>
      <!-- Including any attributes it has and any child nodes -->
      <xsl:apply-templates select="@*|node()"/>
    </xsl:copy>
  </xsl:template>

<xsl:template match="@*">
    <!-- Create the same element with a lowercase name -->
    <xsl:attribute name="{translate(name(),'ABCDEFGHIJKLMNOPQRSTUVWXYZ',
                                         'abcdefghijklmnopqrstuvwxyz')}">
      <!-- Including any attributes it has and any child nodes -->
      <xsl:apply-templates select="@*|node()"/>
	<xsl:value-of select="."/>
    </xsl:attribute>
  </xsl:template>

  <!-- When you match any element -->
  <xsl:template match="*">
    <!-- Create the same element with a lowercase name -->
    <xsl:element name="{translate(name(),'ABCDEFGHIJKLMNOPQRSTUVWXYZ',
                                         'abcdefghijklmnopqrstuvwxyz')}">
      <!-- Including any attributes it has and any child nodes -->
      <xsl:apply-templates select="@*|node()"/>
    </xsl:element>
  </xsl:template>

<xsl:template match="h1|h2|h3|h4">
<section><xsl:call-template name='att'/></section>
</xsl:template>

<xsl:template match="b">
<emphasis role='strong'><xsl:call-template name='att'/></emphasis>
</xsl:template>

<xsl:template match="i">
<emphasis><xsl:call-template name='att'/></emphasis>
</xsl:template>

<xsl:template match="span">
<xsl:call-template name='att'/>
</xsl:template>

<xsl:template match="p">
<para><xsl:call-template name='att'/></para>
</xsl:template>

<xsl:template match="ul">
<itemizedlist><xsl:call-template name='att'/></itemizedlist>
</xsl:template>
<xsl:template match="li">
<listitem><xsl:call-template name='att'/></listitem>
</xsl:template>

<xsl:template match="img">
<mediaobject><imageobject><imagedata fileref='{@src}' format='jpg'><xsl:apply-templates/>
</imagedata></imageobject></mediaobject>
</xsl:template>

</xsl:stylesheet>
